var Marvin = (function () {
    function Marvin(x, y) {
        this.position = new Vector2(x, y);
        this.movement = {
            left: true
        };
        this.velocity = -5;
        this.width = 100.2;
        this.height = 100;
        this.animation = new Animation(
            this.width,
            this.height,
            1,
            1,
            4,
            'images/marvinSpaceship.png',
            15,
            4,
            1
        );

        this.boundingBox = new Rectangle(
            x,
            y,
            this.width,
            this.height
        );
    }

    Yosemity.prototype.update = function () {
        if (this.movement.left) {
            this.position.x += this.velocity;
            if (this.position.x <= 100) {
                this.movement.left = false;
            }
        } else if (!this.movement.left) {
            this.position.x -= this.velocity;
            if (this.position.x >= 900) {
                this.movement.left = true;
            }
        }

        this.animation.position.set(this.position.x, this.position.y);
        this.boundingBox.x = this.position.x;
        this.boundingBox.y = this.position.y;
        this.animation.update();
    };


    Yosemity.prototype.render = function (ctx) {
        if (this.movement.left) {
            this.animation.setLimit(4);
            this.animation.setRow(1);
        } else if (!this.movement.left) {
            this.animation.setLimit(4);
            this.animation.setRow(0);
        }
        this.animation.draw(ctx);
    };

    return Marvin;
}());